

 
import javax.swing.*;
import java.awt.Graphics;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.applet.*;
import java.awt.image.*;
import java.net.*;
import java.net.URL;
import java.io.*;
import java.util.*;


public class schoolset extends java.applet.Applet implements Runnable {
  Thread animator;
  boolean paused = false;
  swarmCanvas arena;
  swarmPanel controls;

  public void init() { // initialise applet components
    Image img;  
    img = getImage(getCodeBase(),"aquarium.jpg");
    
    arena = new swarmCanvas();
    arena.img=img;
    controls = new swarmPanel();
    setLayout(new BorderLayout());
    add("Center", arena); // add canvas to applet at 'Center'
    add("South", controls); // add panel to applet at 'South'
    arena.requestFocus();
  }

  public void start() { // start thread when applet starts
    if (animator == null) {
      animator = new Thread(this);
      animator.start();
    }
  }

  public void stop() { // stop thread when applet stops
    if (animator != null) {
      animator.stop();
      animator = null;
    }
  }

  public void run() {
    boolean school1ing = false;
    while (true) {
      if (!school1ing && arena.unpacked) { // once canvas component is unpacked
        fish.setBoundaries(arena.w, arena.h); // set swarm boundaries
        arena.school1 = new school(5, 15); // add school1
        school1ing = true;
      } else if (school1ing) {
        fish.setBoundaries(arena.w, arena.h);
        if (!paused)
          arena.school1.move(); // animate the school1
        arena.repaint(); // update display
      }
      try {
        Thread.sleep(40); // interval between steps
      } catch (InterruptedException e) {}
    }
  }

  public boolean handleEvent(Event ev) { // check for control panel actions
    if (ev.id == Event.ACTION_EVENT && ev.target == controls.reset) {
      resetApplet(); // reset button pressed in controls
      return true;
    }
    if (ev.id == Event.ACTION_EVENT && ev.target == controls.pause) {
      paused = !paused; // toggle paused status
      controls.pause.setLabel((paused) ? "Continue" : "Pause");
      return true;
    }
    if (ev.id == Event.SCROLL_LINE_UP && ev.target == controls.sbRed) {
      arena.school1.removeFish(Color.red); // remove red Fish from school1
      return true;
    }
    if (ev.id == Event.SCROLL_LINE_DOWN && ev.target == controls.sbRed) {
      arena.school1.addFish(new fish(Color.red)); // add red Fish to school1
      return true;
    }
    if (ev.id == Event.SCROLL_LINE_UP && ev.target == controls.sbBlue) {
      arena.school1.removeFish(Color.blue); // remove blue Fish from school1
      return true;
    }
    if (ev.id == Event.SCROLL_LINE_DOWN && ev.target == controls.sbBlue) {
      arena.school1.addFish(new fish(Color.blue)); // add blue Fish to school1
      return true;
    }
    return super.handleEvent(ev);
  }

  public boolean keyDown(Event e, int x) { // check for key press
    int flags = e.modifiers; // check for modifier keys
    boolean shiftKeyDown = ((flags & Event.SHIFT_MASK) != 0);
    if (shiftKeyDown) {
      if (x == Event.DOWN) school.minDISTANCE -= 5; // less separation
      if (x == Event.UP) school.minDISTANCE += 5; // more separation
      if (x == Event.LEFT) school.maxDISTANCE -= 5; // lower detection
      if (x == Event.RIGHT) school.maxDISTANCE += 5; // higher detection
      hurdle.minRANGE = school.minDISTANCE;
      hurdle.maxRANGE = school.maxDISTANCE;
    } else {
      if (x == Event.DOWN) fish.maxSPEED -= 1.0; // slower
      if (x == Event.UP) fish.maxSPEED += 1.0; // faster
      if (x == Event.LEFT) fish.maxTURN -= 5; // less turning
      if (x == Event.RIGHT) fish.maxTURN += 5; // more turning
    }
    return true; // all key events handled
  }

  public void resetApplet() {
    arena.school1 = new school(15, 5); // create new school1
    controls.sbBlue.setValue(15); // initialise scrollbars
    controls.sbRed.setValue(5);
    fish.maxSPEED = 5.0; // initialise parameters
    fish.maxTURN = 15;
    school.minDISTANCE = 15;
    school.maxDISTANCE = 60;
    hurdle.minRANGE = school.minDISTANCE; // pass new values to Barrier class
    hurdle.maxRANGE = school.maxDISTANCE;
  }
}

/********************************************************/

class swarmPanel extends Panel { // class defines applet control panel
  Button reset, pause;
  Scrollbar sbBlue;
  Scrollbar sbRed;
  Label label1;
  Label label2;
  Image img;
/* Create and add control panel components */
  swarmPanel() {
    setLayout(new GridLayout(2, 3)); // define 2 x 3 grid layout for controls
    label1 = new Label("Blue #");
    //img=getImage(getCodeBase(),"aquarium.jpg");
    label1.setFont(new Font("Dialog", Font.PLAIN, 12)); add(label1);
    label2 = new Label("Red #");
    label2.setFont(new Font("Dialog", Font.PLAIN, 12)); add(label2);
    reset = new Button("Reset"); add(reset);
    sbBlue = new Scrollbar(Scrollbar.HORIZONTAL, 15, 1, 0, 40); add(sbBlue);
    sbRed = new Scrollbar(Scrollbar.HORIZONTAL, 5, 1, 0, 40); add(sbRed);
    pause = new Button("Pause"); add(pause);
  }
}

/********************************************************/

class swarmCanvas extends Canvas {
  school school1;
  Image offScrImg;//=getImage(getCodeBase(),"aquarium.jpg");;
  Image img;
  boolean unpacked = false;
  int w, h;

/* Double buffered graphics */
  public void update(Graphics g) {
    if (offScrImg == null || offScrImg.getWidth(this) != w || offScrImg.getHeight(this) != h)
      offScrImg =createImage(w, h);

    Graphics og = offScrImg.getGraphics();
     //og.drawImage(offScrImg, 0, 0, this);
    paint(og);
    // img=getImage(getCodeBase(),"aquarium.jpg");
    g.drawImage(offScrImg, 0, 0, this);
    
    og.dispose();

  }

  public void paint(Graphics g) {
    Dimension d = this.preferredSize();
    if (!unpacked) {
      this.w = d.width;
      this.h = d.height;
      unpacked = true;
    }
    g.setColor(Color.blue);
    
    g.fillRect(0, 0, w, h); // draw white background
    g.setColor(Color.black); // set font and write applet parameters
    g.setFont(new Font("Dialog", Font.PLAIN, 10));
    g.drawString("Fish Speed: " + fish.maxSPEED, 10, 15);
    g.drawString("Fish Turning: " + fish.maxTURN, 10, 30);
    g.drawString("Minimum Distance: " + school.minDISTANCE, 10, 45);
    g.drawString("Maximum Distance: " + school.maxDISTANCE, 10, 60);
     
    school1.display(g); // draw Flock members
    if (this.w != d.width || this.h != d.height)
      unpacked = false;
  }
}